import{s as Oe,f as q,n as We,o as Ke}from"../chunks/scheduler.37c15a92.js";import{S as De,i as Ne,g as l,s as i,r as U,A as Qe,h as r,f as n,c as s,j as Fe,u as A,x as o,k as g,y as Ve,a,v as J,d as z,t as B,w as F}from"../chunks/index.7cb9c9b8.js";import{H as K,E as Xe}from"../chunks/EditOnGithub.858acfec.js";function Ye(Te){let u,D,O,N,m,Q,p,ye,V,c,xe='SnowballTarget is an environment we created at Hugging Face using assets from <a href="https://kaylousberg.com/" rel="nofollow">Kay Lousberg</a>. We have an optional section at the end of this Unit <strong>if you want to learn to use Unity and create your environments</strong>.',X,f,Y,h,Me="The first agent you’re going to train is called Julien the bear 🐻. Julien is trained <strong>to hit targets with snowballs</strong>.",Z,v,Ce="The Goal in this environment is that Julien <strong>hits as many targets as possible in the limited time</strong> (1000 timesteps). It will need <strong>to place itself correctly in relation to the target and shoot</strong>to do that.",ee,d,He="In addition, to avoid “snowball spamming” (aka shooting a snowball every timestep), <strong>Julien has a “cool off” system</strong> (it needs to wait 0.5 seconds after a shoot to be able to shoot again).",te,w,Le='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/cooloffsystem.gif" alt="Cool Off System"/> <figcaption>The agent needs to wait 0.5s before being able to shoot a snowball again</figcaption>',ne,b,ae,$,Pe="The reward function is simple. <strong>The environment gives a +1 reward every time the agent’s snowball hits a target</strong>. Because the agent’s Goal is to maximize the expected cumulative reward, <strong>it will try to hit as many targets as possible</strong>.",ie,_,Ie,se,T,Ge=`We could have a more complex reward function (with a penalty to push the agent to go faster, for example). But when you design an environment, you need to avoid the <em>reward engineering problem</em>, which is having a too complex reward function to force your agent to behave as you want it to do.
Why? Because by doing that, <strong>you might miss interesting strategies that the agent will find with a simpler reward function</strong>.`,le,y,Ee="In terms of code, it looks like this:",re,x,Se,oe,M,ge,C,ke="Regarding observations, we don’t use normal vision (frame), but <strong>we use raycasts</strong>.",ue,H,Re="Think of raycasts as lasers that will detect if they pass through an object.",me,L,je='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/raycasts.png" alt="Raycasts"/> <figcaption>Source: <a href="https://github.com/Unity-Technologies/ml-agents">ML-Agents documentation</a></figcaption>',pe,P,qe="In this environment, our agent has multiple set of raycasts:",ce,I,Ue,fe,G,Ae="In addition to raycasts, the agent gets a “can I shoot” bool as observation.",he,E,Je,ve,S,de,k,ze="The action space is discrete:",we,R,Be,be,j,$e,W,_e;return m=new K({props:{title:"The SnowballTarget Environment",local:"the-snowballtarget-environment",headingTag:"h1"}}),f=new K({props:{title:"The agent’s Goal",local:"the-agents-goal",headingTag:"h2"}}),b=new K({props:{title:"The reward function and the reward engineering problem",local:"the-reward-function-and-the-reward-engineering-problem",headingTag:"h2"}}),M=new K({props:{title:"The observation space",local:"the-observation-space",headingTag:"h2"}}),S=new K({props:{title:"The action space",local:"the-action-space",headingTag:"h2"}}),j=new Xe({props:{source:"https://github.com/huggingface/deep-rl-class/blob/main/units/en/unit5/snowball-target.mdx"}}),{c(){u=l("meta"),D=i(),O=l("p"),N=i(),U(m.$$.fragment),Q=i(),p=l("img"),V=i(),c=l("p"),c.innerHTML=xe,X=i(),U(f.$$.fragment),Y=i(),h=l("p"),h.innerHTML=Me,Z=i(),v=l("p"),v.innerHTML=Ce,ee=i(),d=l("p"),d.innerHTML=He,te=i(),w=l("figure"),w.innerHTML=Le,ne=i(),U(b.$$.fragment),ae=i(),$=l("p"),$.innerHTML=Pe,ie=i(),_=l("img"),se=i(),T=l("p"),T.innerHTML=Ge,le=i(),y=l("p"),y.textContent=Ee,re=i(),x=l("img"),oe=i(),U(M.$$.fragment),ge=i(),C=l("p"),C.innerHTML=ke,ue=i(),H=l("p"),H.textContent=Re,me=i(),L=l("figure"),L.innerHTML=je,pe=i(),P=l("p"),P.textContent=qe,ce=i(),I=l("img"),fe=i(),G=l("p"),G.textContent=Ae,he=i(),E=l("img"),ve=i(),U(S.$$.fragment),de=i(),k=l("p"),k.textContent=ze,we=i(),R=l("img"),be=i(),U(j.$$.fragment),$e=i(),W=l("p"),this.h()},l(e){const t=Qe("svelte-u9bgzb",document.head);u=r(t,"META",{name:!0,content:!0}),t.forEach(n),D=s(e),O=r(e,"P",{}),Fe(O).forEach(n),N=s(e),A(m.$$.fragment,e),Q=s(e),p=r(e,"IMG",{src:!0,alt:!0}),V=s(e),c=r(e,"P",{"data-svelte-h":!0}),o(c)!=="svelte-tjcuuk"&&(c.innerHTML=xe),X=s(e),A(f.$$.fragment,e),Y=s(e),h=r(e,"P",{"data-svelte-h":!0}),o(h)!=="svelte-1n4q7lh"&&(h.innerHTML=Me),Z=s(e),v=r(e,"P",{"data-svelte-h":!0}),o(v)!=="svelte-1kbt7gr"&&(v.innerHTML=Ce),ee=s(e),d=r(e,"P",{"data-svelte-h":!0}),o(d)!=="svelte-dkh5jq"&&(d.innerHTML=He),te=s(e),w=r(e,"FIGURE",{"data-svelte-h":!0}),o(w)!=="svelte-1m1t9ww"&&(w.innerHTML=Le),ne=s(e),A(b.$$.fragment,e),ae=s(e),$=r(e,"P",{"data-svelte-h":!0}),o($)!=="svelte-d7uy51"&&($.innerHTML=Pe),ie=s(e),_=r(e,"IMG",{src:!0,alt:!0}),se=s(e),T=r(e,"P",{"data-svelte-h":!0}),o(T)!=="svelte-17at3tr"&&(T.innerHTML=Ge),le=s(e),y=r(e,"P",{"data-svelte-h":!0}),o(y)!=="svelte-1sp5sxs"&&(y.textContent=Ee),re=s(e),x=r(e,"IMG",{src:!0,alt:!0}),oe=s(e),A(M.$$.fragment,e),ge=s(e),C=r(e,"P",{"data-svelte-h":!0}),o(C)!=="svelte-h5sa4r"&&(C.innerHTML=ke),ue=s(e),H=r(e,"P",{"data-svelte-h":!0}),o(H)!=="svelte-1sy1glw"&&(H.textContent=Re),me=s(e),L=r(e,"FIGURE",{"data-svelte-h":!0}),o(L)!=="svelte-1ihdfq4"&&(L.innerHTML=je),pe=s(e),P=r(e,"P",{"data-svelte-h":!0}),o(P)!=="svelte-q67na8"&&(P.textContent=qe),ce=s(e),I=r(e,"IMG",{src:!0,alt:!0}),fe=s(e),G=r(e,"P",{"data-svelte-h":!0}),o(G)!=="svelte-jiha0j"&&(G.textContent=Ae),he=s(e),E=r(e,"IMG",{src:!0,alt:!0}),ve=s(e),A(S.$$.fragment,e),de=s(e),k=r(e,"P",{"data-svelte-h":!0}),o(k)!=="svelte-1dhzfig"&&(k.textContent=ze),we=s(e),R=r(e,"IMG",{src:!0,alt:!0}),be=s(e),A(j.$$.fragment,e),$e=s(e),W=r(e,"P",{}),Fe(W).forEach(n),this.h()},h(){g(u,"name","hf:doc:metadata"),g(u,"content",Ze),q(p.src,ye="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowballtarget.gif")||g(p,"src",ye),g(p,"alt","SnowballTarget"),q(_.src,Ie="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowballtarget_reward.png")||g(_,"src",Ie),g(_,"alt","Reward system"),q(x.src,Se="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowballtarget-reward-code.png")||g(x,"src",Se),g(x,"alt","Reward"),q(I.src,Ue="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowball_target_raycasts.png")||g(I,"src",Ue),g(I,"alt","Raycasts"),q(E.src,Je="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowballtarget-obs-code.png")||g(E,"src",Je),g(E,"alt","Obs"),q(R.src,Be="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowballtarget_action_space.png")||g(R,"src",Be),g(R,"alt","Action Space")},m(e,t){Ve(document.head,u),a(e,D,t),a(e,O,t),a(e,N,t),J(m,e,t),a(e,Q,t),a(e,p,t),a(e,V,t),a(e,c,t),a(e,X,t),J(f,e,t),a(e,Y,t),a(e,h,t),a(e,Z,t),a(e,v,t),a(e,ee,t),a(e,d,t),a(e,te,t),a(e,w,t),a(e,ne,t),J(b,e,t),a(e,ae,t),a(e,$,t),a(e,ie,t),a(e,_,t),a(e,se,t),a(e,T,t),a(e,le,t),a(e,y,t),a(e,re,t),a(e,x,t),a(e,oe,t),J(M,e,t),a(e,ge,t),a(e,C,t),a(e,ue,t),a(e,H,t),a(e,me,t),a(e,L,t),a(e,pe,t),a(e,P,t),a(e,ce,t),a(e,I,t),a(e,fe,t),a(e,G,t),a(e,he,t),a(e,E,t),a(e,ve,t),J(S,e,t),a(e,de,t),a(e,k,t),a(e,we,t),a(e,R,t),a(e,be,t),J(j,e,t),a(e,$e,t),a(e,W,t),_e=!0},p:We,i(e){_e||(z(m.$$.fragment,e),z(f.$$.fragment,e),z(b.$$.fragment,e),z(M.$$.fragment,e),z(S.$$.fragment,e),z(j.$$.fragment,e),_e=!0)},o(e){B(m.$$.fragment,e),B(f.$$.fragment,e),B(b.$$.fragment,e),B(M.$$.fragment,e),B(S.$$.fragment,e),B(j.$$.fragment,e),_e=!1},d(e){e&&(n(D),n(O),n(N),n(Q),n(p),n(V),n(c),n(X),n(Y),n(h),n(Z),n(v),n(ee),n(d),n(te),n(w),n(ne),n(ae),n($),n(ie),n(_),n(se),n(T),n(le),n(y),n(re),n(x),n(oe),n(ge),n(C),n(ue),n(H),n(me),n(L),n(pe),n(P),n(ce),n(I),n(fe),n(G),n(he),n(E),n(ve),n(de),n(k),n(we),n(R),n(be),n($e),n(W)),n(u),F(m,e),F(f,e),F(b,e),F(M,e),F(S,e),F(j,e)}}}const Ze='{"title":"The SnowballTarget Environment","local":"the-snowballtarget-environment","sections":[{"title":"The agent’s Goal","local":"the-agents-goal","sections":[],"depth":2},{"title":"The reward function and the reward engineering problem","local":"the-reward-function-and-the-reward-engineering-problem","sections":[],"depth":2},{"title":"The observation space","local":"the-observation-space","sections":[],"depth":2},{"title":"The action space","local":"the-action-space","sections":[],"depth":2}],"depth":1}';function et(Te){return Ke(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class it extends De{constructor(u){super(),Ne(this,u,et,Ye,Oe,{})}}export{it as component};
